/* This is "integ.h", written to accompany Introduction to
   Scientific Programming by Joseph L. Zachary. */



/* Approximates the definite integral of "integrand" between
   a low bound of "a" and a high bound of "b" using the
   rectangular method with "n" trapezoids. */

double rectangular (double a, double b, int n,
		    double integrand (double));



/* Approximates the definite integral of "integrand" between
   a low bound of "a" and a high bound of "b" using the
   trapezoidal method with "n" trapezoids. */

double trapezoidal (double a, double b, int n,
		    double integrand (double));
