(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = subsection; inactive; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Times New Roman"; fontSize = 12; ]
This notebook contains the Mathematica commands from Chapter 2 of
Introduction to Scientific Programming by Joseph L. Zachary.
:[font = text; inactive; startGroup; ]

(2.1)  The simplest kind of an expession is a number.  It evaluates to itself.
:[font = input; endGroup; nowordwrap; ]
57.8
:[font = text; inactive; startGroup; ]

(2.2)  This ill-formed number is an example of a syntax error.  Since 
Mathematica cannot make sense of it, it reports an errror.
:[font = input; endGroup; nowordwrap; ]
57,8
:[font = text; inactive; startGroup; ]

(2.3)  Here we compute the quotient of two rational numbers.  Notice that the 
answer is expressed as an exact fraction in lowest terms.
:[font = input; endGroup; nowordwrap; ]
57800000 / 5713000000
:[font = text; inactive; startGroup; ]

(2.4)  We demonstrate that the quotient from (2.3) is exact by multiplying it 
by the divisor, which yields the dividend.
:[font = input; endGroup; nowordwrap; ]
289/28565 * 5713000000
:[font = text; inactive; startGroup; ]

(2.5)  We do the same computation as in (2.3), but this time using floating-
point numbers.  We know these are floating-point numbers because they contain 
decimal points.  The answer is rounded off to ten digits, not counting the 
leading zero.
:[font = input; endGroup; nowordwrap; ]
57800000. / 5713000000.
:[font = text; inactive; startGroup; ]

(2.6)  We do the computation from (2.5) one more time, this time using 
scientific notation to write the floating-point numbers.
:[font = input; endGroup; nowordwrap; ]
57.8*10^6 / (5.713*10^9)
:[font = text; inactive; startGroup; ]

(2.7)  We illustrate that floating-point arithmetic is not exact by 
multiplying the quotient from the previous example by the divisor.  The number
 that we get back is almost, but not exactly, the same as the dividend.
:[font = input; endGroup; nowordwrap; ]
.0101173 * 5.713*10^9
:[font = text; inactive; startGroup; ]

(2.8)  This illustrates how, by canelling units, Mathematica does dimensional 
analysis.
:[font = input; endGroup; nowordwrap; ]
72 in * 2.54 cm/in
:[font = text; inactive; startGroup; ]

(2.9)  Here we square a rational number by using the exponentiation operator.
:[font = input; endGroup; nowordwrap; ]
5280^2
:[font = text; inactive; startGroup; ]

(2.10)  This example shows how floating-point and rational numbers can be 
mixed in a single expression.  Because a floating-point number is involved, 
the answer is expressed as a floating-point number.
:[font = input; endGroup; nowordwrap; ]
.0101173 * 27878400
:[font = text; inactive; startGroup; ]

(2.11)  We repeat the calculation from (2.10), this time using only rational 
numbers.  Notice that the result is expressed as a rational number.
:[font = input; endGroup; nowordwrap; ]
289/28565 * 27878400
:[font = text; inactive; startGroup; ]

(2.12)  Here we divide two floating-point numbers, obtaining an intermediate 
floating-point result, which we multiply by a rational number.  Because the 
final multiplication involves both a floating-point number and a rational 
number, the rational number is first converted into floating-point form.
:[font = input; endGroup; nowordwrap; ]
(57.8*10^6 / (5.713*10^9)) * 27878400
:[font = text; inactive; startGroup; ]

(2.13)  This is the same calculation as in (2.12), but here we explicitly 
compute the square of 5280.
:[font = input; endGroup; nowordwrap; ]
(57.8*10^6 / (5.713*10^9)) * (5280^2)
:[font = text; inactive; startGroup; ]

(2.14)  This is an example of the user of the "Sqrt" built-in function.  It 
returns the square root of its parameter.
:[font = input; endGroup; nowordwrap; ]
Sqrt[282053.]
:[font = text; inactive; startGroup; ]

(2.15)  The parameter to "Sqrt" can be an arbitrary expression.  Here we take 
the square root of the value of an expression that involves division, 
exponentiation, and multiplication.
:[font = input; endGroup; nowordwrap; ]
Sqrt[(57.8*10^6 / (5.713*10^9)) * (5280^2)]
:[font = text; inactive; startGroup; ]

(2.16)  Here we take the same square root as in (2.15), but we use rational 
numbers.  An exact result is produced using a radical.
:[font = input; endGroup; nowordwrap; ]
Sqrt[(57800000 / 5713000000) * (5280^2)]
:[font = text; inactive; startGroup; ]

(2.17)  The "N" built-in function converts a rational number into floating-
point form.
:[font = input; endGroup; nowordwrap; ]
N[17952 * Sqrt[5/5713]]
:[font = text; inactive; startGroup; ]

(2.18)  Mathematica 2.2 does not permit the entry of typeset mathematics.
This is the best we can do.
:[font = input; endGroup; nowordwrap; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Courier New"; fontSize = 12; ]
Sqrt[282053.]
:[font = text; inactive; startGroup; ]

(2.19)  Similarly, this is the best we can do here.
:[font = input; endGroup; nowordwrap; backColorRed = 65535; backColorGreen = 65535; backColorBlue = 65535; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Courier New"; fontSize = 12; ]
Sqrt[(57800000/5713000000) * 5280^2]
:[font = text; inactive; startGroup; ]

(2.21)  There is a limit on the sizes of rational numbers that can be 
computed.  Although the limit aries from computer to computer, this expression
 will probably exceed the limit on your computer.  You will almost certainly 
end up having to abort the computation.
:[font = input; endGroup; nowordwrap; ]
10^600000
:[font = text; inactive; startGroup; ]

(2.22)  Even though this expression involves large exponents, Mathematica is 
able to quickly reduce this to 1.
:[font = input; endGroup; nowordwrap; ]
10^(600000-600000)
:[font = text; inactive; startGroup; ]

(2.23)  This is algebraically identical to (2.22), but you will nevertheless 
have to abort this calculation.
:[font = input; endGroup; nowordwrap; ]
10^600000 / 10^600000
:[font = text; inactive; startGroup; ]

(2.24)  The value of this constant is the precision of Mathematica's floating-
point numbers on your computer.
:[font = input; endGroup; nowordwrap; ]
$MachinePrecision
:[font = text; inactive; startGroup; ]

(2.25)  This is an exact rational calculation ...
:[font = input; endGroup; nowordwrap; ]
1234567890^2
:[font = text; inactive; startGroup; ]

(2.26)  ... and this is the same calculation done with floating-point numbers.
  Notice that Mathematica only displays the first six digits of the mantissa.
:[font = input; endGroup; nowordwrap; ]
1234567890.^2.
:[font = text; inactive; startGroup; ]

(2.27)  By using the built-in function "InputForm", we can see all of the 
digits of the number calculated in (2.26).  Notice that only 16 digits are 
available, even though there were 17 digits in the rational answer calculated 
in (2.25).
:[font = input; endGroup; nowordwrap; ]
InputForm[1234567890.^2.]
:[font = text; inactive; startGroup; ]

(2.28)  Here we look at all of the digits in a quotient we evaluated several 
times earlier.
:[font = input; endGroup; nowordwrap; ]
InputForm[57.8*10^6 / (5.713*10^9)]
:[font = text; inactive; startGroup; ]

(2.29)  We use the 16-digit result from (2.28) to recalculate (2.10), where we
 earlier used only a six-digit multiplicand.  The product differs in the sixth
 digit.
:[font = input; endGroup; nowordwrap; ]
0.01011727638718711 * 27878400
:[font = text; inactive; startGroup; ]

(2.30)  This is the largest floating-point number on your computer.
:[font = input; endGroup; nowordwrap; ]
$MaxMachineNumber
:[font = text; inactive; startGroup; ]

(2.31)  And this is the smallest floating-point number on your computer.
:[font = input; endGroup; nowordwrap; ]
$MinMachineNumber
:[font = text; inactive; startGroup; ]

(2.32)  If you try to calculate a floating-point number that is too big, you'
ll get an overflow error.
:[font = input; endGroup; nowordwrap; ]
10.^1000000000.
:[font = text; inactive; startGroup; ]

(2.33)  And if you try to calculate a floating-point number that is too small,
 you'll get an underflow error.
:[font = input; endGroup; nowordwrap; ]
10.^-1000000000.
:[font = text; inactive; startGroup; ]

(2.34)  These are all of the digits in the floating-point calculation for the 
problem studied in Chapter 2.
:[font = input; endGroup; nowordwrap; ]
InputForm[Sqrt[(57.8*10^6 / (5.713*10^9)) * (5280.^2)]]
:[font = text; inactive; startGroup; ]

(2.35)  And these are all the digits in the rational calculation, after it has
 been converted to floating-point form at the last step.
:[font = input; endGroup; nowordwrap; ]
InputForm[N[17952 * Sqrt[5/5713]]]
^*)