(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Times New Roman", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Times New Roman", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Times New Roman", 14, L0, center, nohscroll, bold;
	fontset = section, "Times New Roman", 14, L0, bold, grayBox;
	fontset = subsection, "Times New Roman", 12, L0, bold, blackBox;
	fontset = subsubsection, "Times New Roman", 10, L0, bold, whiteBox;
	fontset = text, "Times New Roman", 12, L0;
	fontset = smalltext, "Times New Roman", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65535;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Times New Roman", 10, L0, nohscroll, italic, B65535;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Times New Roman", 10, L0, nohscroll;
	fontset = clipboard, "Times New Roman", 12, L0, nohscroll;
	fontset = completions, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Times New Roman", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Times New Roman", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Times New Roman", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = subsection; inactive; ]
This notebook contains the Mathematica commands from Chapter 4 of Introduction
 to Scientific Programming by Joseph L. Zachary.
:[font = text; inactive; ]

(4.2)  We use rational arithmetic to add up the reciprocals of the first ten 
even numbers.  The answer is exact.
:[font = input; nowordwrap; ]
rat10 = 1/2 + 1/4 + 1/6 + 1/8 + 1/10 + 1/12 +
        1/14 + 1/16 + 1/18 + 1/20
:[font = text; inactive; ]

(4.3)  This is a six-digit floating-point approximations to the rational sum 
from (4.2).
:[font = input; nowordwrap; ]
N[rat10]
:[font = text; inactive; ]

(4.4)  We use floating-point arithmetic to add up the reciprocals of the first
 ten even numbers.  We get the same answer as in (4.3).
:[font = input; nowordwrap; ]
float10 = 1/2. + 1/4. + 1/6. + 1/8. + 1/10. + 1/12. +
          1/14. + 1/16. + 1/18. + 1/20.
:[font = text; inactive; ]

(4.5)  We load the "Blocks" package from the custom Mathematica library "ISP" 
that accompanies the book.
:[font = input; nowordwrap; ]
Needs["ISP`Blocks`"]
:[font = text; inactive; ]

(4.6)  We display the names of the functions contained in the "Blocks" 
package.
:[font = input; nowordwrap; ]
Names["ISP`Blocks`*"]
:[font = text; inactive; ]

(4.7)  We calculate the sum from (4.2) using "BlockRat".
:[font = input; nowordwrap; ]
BlockRat[10]
:[font = text; inactive; ]

(4.8)  We calculate the sum from (4.3) using "BlockFloat".
:[font = input; nowordwrap; ]
BlockFloat[10]
:[font = text; inactive; ]

(4.9)  We calculate the same sum as in 4.8, but using simulated two-digit 
floating-point numbers.  Notice that quite a bit of roundoff error 
accumulates.
:[font = input; nowordwrap; ]
BlockPrecision[10, 2]
:[font = text; inactive; ]

(4.10)  This calculates the amount of computer time it takes to calculate
"BlockFloat[5000]" on your computer.
:[font = input; nowordwrap; ]
Timing[BlockFloat[5000]]
:[font = text; inactive; ]

(4.11)  Here we see that, using two-digit floating-point arithmetic, the ten-
term sum ...
:[font = input; nowordwrap; ]
BlockPrecision[10, 2]
:[font = text; inactive; ]

(4.12) ... and the twenty-term sum produce the same answer.
:[font = input; nowordwrap; ]
BlockPrecision[20, 2]
:[font = text; inactive; ]

(4.13)  If we sum the terms beginning with the smallest, however, the ten-term
 sum ...
:[font = input; nowordwrap; ]
BlockPrecision[-10, 2]
:[font = text; inactive; ]

(4.14) ... and the twenty-term sum produce different answers.
:[font = input; nowordwrap; ]
BlockPrecision[-20, 2]
:[font = text; inactive; ]

(4.18)  We can exploit a much better method for computing the sum of the first
 billion even terms of the harmonic series.  (We must apply "N" to the constant
"EulerGamma" to obtain a numerical result.)
:[font = input; nowordwrap; ]
0.5 * (PolyGamma[1.*10^9 + 1] + N[EulerGamma])
:[font = text; inactive; ]

(4.19)  The ! operator computes the factorial function.
:[font = input; nowordwrap; ]
5!
^*)